Index: FOIAVistA/tag/r/HEALTH_LEVEL_SEVEN-HL/HLCSTCP.m
===================================================================
--- FOIAVistA/trunk/r/HEALTH_LEVEL_SEVEN-HL/HLCSTCP.m	(revision 631)
+++ FOIAVistA/tag/r/HEALTH_LEVEL_SEVEN-HL/HLCSTCP.m	(revision 636)
@@ -1,65 +1,40 @@
-HLCSTCP ;SFIRMFO/TNV-ALB/JFP,PKE - (TCP/IP) MLLP ;09/19/2007  10:21
- ;;1.6;HEALTH LEVEL SEVEN;**19,43,49,57,58,64,84,109,133,122**;Oct 13, 1995;Build 14
+HLCSTCP ;SFIRMFO/TNV-ALB/JFP,PKE - (TCP/IP) MLLP ;09/13/2006
+ ;;1.6;HEALTH LEVEL SEVEN;**19,43,49,57,58,64,84,109,133**;Oct 13, 1995;Build 13
  ;Per VHA Directive 2004-038, this routine should not be modified.
- ;
+ ; 
  ; This is an implementation of the HL7 Minimal Lower Layer Protocol
- ; taskman entry/startup option, HLDP defined in menu entry.
- ;
+ ;
+ ;taskman entry/startup option, HLDP defined in menu entry,
  Q:'$D(HLDP)
- ; patch HL*1.6*122 start
- L +^HLCS("HLTCPLINK",HLDP):5 I '$T D  Q
- . D MON^HLCSTCP("TskLcked")
- N HLCSOUT,HLDBACK,HLDBSIZE,HLDREAD,HLDRETR,HLRETRA,HLDWAIT,HLOS,HLTCPADD,HLTCPCS,HLTCPLNK,HLTCPORT,HLTCPRET
- N HLZRULE
+ N HLCSOUT,HLDBACK,HLDBSIZE,HLDREAD,HLDRETR,HLRETRA,HLDWAIT,HLOS,HLTCPADD,HLTCPCS,HLTCPLNK,HLTCPORT,HLTCPRET,HLCSFAIL
  ;HLCSOUT= 1-error
  I '$$INIT D EXITS("Init Error") Q
- S HLDP("$J")=$J
- S HLDP("$J",0,"LENGTH")=$L(HLDP("$J"))
  ; Start the client
  I $G(HLTCPCS)="C" D  Q
- . S HLDP("$J",0,"START")=HLDP("$J",0,"LENGTH")-8+$L(HLTCPORT)+$L(HLDP)
- . I HLDP("$J",0,"START")<1 S HLDP("$J",0,"START")=1
- . S HLDP("$J",0)=$E(HLDP("$J"),HLDP("$J",0,"START"),HLDP("$J",0,"LENGTH"))
  . ; identify process for ^%SY
- . ; D SETNM^%ZOSV($E("HLClnt:"_HLDP,1,15))
- . D SETNM^%ZOSV($E("HLc:"_HLTCPORT_"-"_HLDP_"-"_HLDP("$J",0),1,15))
- . K HLDP("$J",0)
+ . D SETNM^%ZOSV($E("HLClnt:"_HLDP,1,15))
  . D ST1
  . F  D ^HLCSTCP2 Q:$$STOP!$G(HLCSOUT)
- . ; I $G(HLCSOUT)=1 D MON("Error") H 1 Q
- . I $G(HLCSOUT)=1 D  Q
- .. D MON("Error") H 1
- .. L -^HLCS("HLTCPLINK",HLDP)
+ . I $G(HLCSOUT)=1 D MON("Error") H 1 Q
  . I $G(HLCSOUT)=2 D EXITS("Inactive") Q
  . D EXITS("Shutdown")
  ;
- S HLDP("$J",0,"START")=HLDP("$J",0,"LENGTH")-9+$L(HLTCPORT)
- I HLDP("$J",0,"START")<1 S HLDP("$J",0,"START")=1
- S HLDP("$J",0)=$E(HLDP("$J"),HLDP("$J",0,"START"),HLDP("$J",0,"LENGTH"))
  ; identify process for ^%SY
- ; D SETNM^%ZOSV($E("HLSrv:"_HLDP,1,15))
- D SETNM^%ZOSV($E("HLs:"_HLTCPORT_"-"_HLDP("$J",0),1,15))
- K HLDP("$J",0)
- ; to stop the listener via updated Kernel API, need to pass the
- ; listener logical link (HLDP)
- S HLZRULE="S HLDP="_HLDP_" S ZISQUIT=$$STOP^HLCSTCP"
+ D SETNM^%ZOSV($E("HLSrv:"_HLDP,1,15))
+ ;HLCSFAIL=1 port failed to open
+ S HLCSFAIL=1
  ;single threaded listener
  I $G(HLTCPCS)="S" D  Q
- . D ST1,MON("Listen"),LISTEN^%ZISTCP(HLTCPORT,"SERVER^HLCSTCP("""_HLDP_""")",HLZRULE)
- . I $$STOP D EXITS("Shutdown") Q
- . D EXITS("Openfail")
- ;
- ;multi-threaded listener (for OpenM/NT)
- I ($G(HLTCPCS)'="M")!(^%ZOSF("OS")'["OpenM") D  Q
- . L -^HLCS("HLTCPLINK",HLDP)
- I $$OS^%ZOSV["VMS" L -^HLCS("HLTCPLINK",HLDP) Q
- D ST1,MON("Listen"),LISTEN^%ZISTCPS(HLTCPORT,"SERVERS^HLCSTCP("""_HLDP_""")",HLZRULE)
- ; update status of listener
- I $$STOP D EXITS("Shutdown") Q
- D EXITS("Openfail")
- ; HL*1.6*122 end
+ . D ST1,MON("Listen"),LISTEN^%ZISTCP(HLTCPORT,"SERVER^HLCSTCP("""_HLDP_""")")
+ . ;couldn't open listener port
+ . I HLCSFAIL D EXITS("Openfail") Q
+ ;
+ ;multi-threaded listener (OpenM)
+ I $G(HLTCPCS)="M",^%ZOSF("OS")["OpenM" D  Q
+ . D ST1,MON("Listen"),LISTEN^%ZISTCPS(HLTCPORT,"SERVERS^HLCSTCP("""_HLDP_""")")
  Q
  ;
 SERVER(HLDP) ; single server using Taskman
+ S HLCSFAIL=0
  I '$$INIT D EXITS("Init error") Q
  D ^HLCSTCP1
@@ -80,18 +55,26 @@
  G LISTEN
  ;
+CACHEVMS(%) ;Cache'/VMS tcpip/ucx entry point, called from HLSEVEN.COM file,
+ ;listener,  % = HLDP
+ I $G(%)="" D ^%ZTER Q
+ S IO="SYS$NET",HLDP=%
+ S IO(0)="_NLA0:" O IO(0) ;Setup null device
+ ; **Cache'/VMS specific code**
+ O IO::5 E  D MON("Openfail") Q
+ X "U IO:(::""-M"")" ;Packet mode like DSM
+ D LISTEN C IO Q
+ ;
+EN ;vms ucx entry point, called from HLSEVEN.COM file,
+ ;listener,  % = device^HLDP
+ I $G(%)="" D ^%ZTER Q
+ S IO="SYS$NET",U="^",HLDP=$P(%,U,2)
+ S IO(0)="_NLA0:" O IO(0) ;Setup null device
+ ; **VMS specific code, need to share device**
+ O IO:(TCPDEV):60 E  D MON("Openfail") Q
 LISTEN ;
- N HLLSTN,HLCSOUT,HLDBACK,HLDBSIZE,HLDREAD,HLDRETR,HLRETRA,HLDWAIT,HLOS,HLTCPADD,HLTCPCS,HLTCPLNK,HLTCPORT,HLTCPRET
+ N HLLSTN,HLCSOUT,HLDBACK,HLDBSIZE,HLDREAD,HLDRETR,HLRETRA,HLDWAIT,HLOS,HLTCPADD,HLTCPCS,HLTCPLNK,HLTCPORT,HLTCPRET,HLCSFAIL
  I '$$INIT D ^%ZTER Q
- ; patch HL*1.6*122 start
- S HLDP("$J")=$J
- S HLDP("$J",0,"LENGTH")=$L(HLDP("$J"))
- S HLDP("$J",0,"START")=HLDP("$J",0,"LENGTH")-9+$L(HLTCPORT)
- I HLDP("$J",0,"START")<1 S HLDP("$J",0,"START")=1
- S HLDP("$J",0)=$E(HLDP("$J"),HLDP("$J",0,"START"),HLDP("$J",0,"LENGTH"))
  ; identify process for ^%SY
- ; D SETNM^%ZOSV($E("HLSrv:"_HLDP,1,15))
- D SETNM^%ZOSV($E("HLs:"_HLTCPORT_"-"_HLDP("$J",0),1,15))
- K HLDP("$J",0)
- ; patch HL*1.6*122 end
+ D SETNM^%ZOSV($E("HLSrv:"_HLDP,1,15))
  ;HLLSTN used to identify a listener to tag MON
  S HLLSTN=1
@@ -110,11 +93,9 @@
  S HLOS=$P($G(^%ZOSF("OS")),"^")
  N DA,DIQUIET,DR,TMP,X,Y
- S IOF=$$FLUSHCHR^%ZISTCP ; HL*1.6*122 set device flush character
  S DIQUIET=1
  D DT^DICRW
  I 'HLDP S HLDP=$O(^HLCS(870,"B",HLDP,0)) I 'HLDP Q 0
  S DA=HLDP
- ; patch HL*1.6*122 for field 400.09
- S DR="200.02;200.021;200.022;200.03;200.04;200.05;200.09;400.01;400.02;400.03;400.04;400.05;400.09"
+ S DR="200.02;200.021;200.022;200.03;200.04;200.05;200.09;400.01;400.02;400.03;400.04;400.05"
  D GETS^DIQ(870,DA,DR,"IN","TMP","TMP")
  ;
@@ -144,19 +125,10 @@
  S HLTCPRET=$G(TMP(870,DA_",",400.05,"I"))
  ;
- ; patch HL*1.6*122 for field 400.09
- ; -- tcp/ip openfail timeout
- S HLTCPLNK("TIMEOUT")=$G(TMP(870,DA_",",400.09,"I"))
- ;
  ; -- set defaults in case something's not set
  S:HLDREAD=0 HLDREAD=10
  S:HLDBACK=0 HLDBACK=60
- ; patch HL*1.6*122
- ; S:HLDBSIZE=0 HLDBSIZE=245
- S:HLDBSIZE<245 HLDBSIZE=245
+ S:HLDBSIZE=0 HLDBSIZE=245
  S:HLDRETR=0 HLDRETR=5
  S:HLTCPRET="" X=$P($$PARAM^HLCS2,U,12),HLTCPRET=$S(X:X,1:15)
- ;
- ; patch HL*1.6*122 for field 400.09
- S:HLTCPLNK("TIMEOUT")=0 HLTCPLNK("TIMEOUT")=5
  ;
  Q 1
@@ -166,6 +138,5 @@
  ;14=Shutdown LLP, 3=LLP Online, 18=Gross Errors
  N HLJ,X
- ; HL*1.6*122 remove unnecessary locks
- ;F  L +^HLCS(870,HLDP,0):2 Q:$T
+ F  L +^HLCS(870,HLDP,0):2 Q:$T
  S X="HLJ(870,"""_HLDP_","")"
  S @X@(4)="Init",(@X@(10),@X@(18))="@",@X@(14)=0
@@ -175,5 +146,5 @@
  S:$G(ZTSK) @X@(11)=ZTSK
  D FILE^HLDIE("","HLJ","","ST1","HLCSTCP") ;HL*1.6*109
- ;L -^HLCS(870,HLDP,0)
+ L -^HLCS(870,HLDP,0)
  Q
  ;
@@ -181,37 +152,21 @@
  ;don't display for multiple server
  Q:$G(HLLSTN)
- ; HL*1.6*122 remove unnecessary locks
- ;F  L +^HLCS(870,HLDP,0):2 Q:$T
+ F  L +^HLCS(870,HLDP,0):2 Q:$T
  S $P(^HLCS(870,HLDP,0),U,5)=Y
- ;L -^HLCS(870,HLDP,0)
+ L -^HLCS(870,HLDP,0)
  Q:'$D(HLTRACE)
  N X U IO(0)
  W !,"IN State: ",Y
  I '$$STOP D
- . ; patch HL*1.6*122
- . ; R !,"Type Q to Quit: ",X#1:1
- . R !,"Type Q to Quit: ",X:1
- . ; I $L(X),"Qq"[X S $P(^HLCS(870,HLDP,0),U,15)=1
- . I $L(X),"Qq"[$E(X) S $P(^HLCS(870,HLDP,0),U,15)=1
- . ; patch HL*1.6*122 end
+ . R !,"Type Q to Quit: ",X#1:1
+ . I $L(X),"Qq"[X S $P(^HLCS(870,HLDP,0),U,15)=1
  U IO
  Q
 UPDT(Y) ;update job count for multiple servers,X=1 increment
  N HLJ,X
- ;
- ; HL*1.6*122 start
- ; F  L +^HLCS(870,HLDP,0):2 Q:$T
- Q:'$G(HLDP)
- Q:'$D(^HLCS(870,"E","M",HLDP))
- F  L +^HLCS(870,HLDP,0):10 Q:$T  H 1
- ; S X=+$P(^HLCS(870,HLDP,0),U,5),$P(^(0),U,5)=$S(Y:X+1,1:X-1)_" server"
- S X=+$P(^HLCS(870,HLDP,0),U,5)
- I X<0 S X=0
- S $P(^HLCS(870,HLDP,0),U,5)=$S(Y:(X+1),X<1:0,1:X-1)_" server"
+ F  L +^HLCS(870,HLDP,0):2 Q:$T
+ S X=+$P(^HLCS(870,HLDP,0),U,5),$P(^(0),U,5)=$S(Y:X+1,1:X-1)_" server"
  ;if incrementing, set the Device Type field to Multi-Server
- ; I X S HLJ(870,HLDP_",",3)="MS" D FILE^HLDIE("","HLJ","","UPDT","HLCSTCP")
- I $P(^HLCS(870,HLDP,0),"^",4)']"" S $P(^HLCS(870,HLDP,0),"^",4)="MS"
- ; HL*1.6*122 end
- ;
+ I X S HLJ(870,HLDP_",",3)="MS" D FILE^HLDIE("","HLJ","","UPDT","HLCSTCP") ;HL*1.6*109
  L -^HLCS(870,HLDP,0)
  Q
@@ -230,31 +185,19 @@
  N P,X
  S P=$S(Y<3:"IN",1:"OUT")_" QUEUE "_$S(Y#2:"BACK",1:"FRONT")_" POINTER"
- ; patch HL*1.6*122 start
- ; F  L +^HLCS(870,DP,P):2 Q:$T
- ; S X=+$G(^HLCS(870,DP,P)),^(P)=X+$S($G(Z):-1,1:1)
- I '$L($G(OS)) N OS S OS=$G(^%ZOSF("OS"))
- I OS'["DSM",OS'["OpenM" D
- . F  L +^HLCS(870,DP,P):10 Q:$T  H 1
- . S X=+$G(^HLCS(870,DP,P)),^(P)=X+$S($G(Z):-1,1:1)
- . L -^HLCS(870,DP,P)
- E  D
- . S X=$I(^HLCS(870,DP,P),$S($G(Z):-1,1:1))
- ; L -^HLCS(870,DP,P)
- ; patch HL*1.6*122 end
+ F  L +^HLCS(870,DP,P):2 Q:$T
+ S X=+$G(^HLCS(870,DP,P)),^(P)=X+$S($G(Z):-1,1:1)
+ L -^HLCS(870,DP,P)
  Q
 SDFLD ; set Shutdown? field to yes
  Q:'$G(HLDP)
- ; HL*1.6*122 remove unnecessary lock and call to FM
- S $P(^HLCS(870,HLDP,0),U,15)=1
- ;N HLJ,X
- ;F  L +^HLCS(870,HLDP,0):2 Q:$T
+ N HLJ,X
+ F  L +^HLCS(870,HLDP,0):2 Q:$T
  ;14=Shutdown LLP?
- ;S HLJ(870,HLDP_",",14)=1
- ;D FILE^HLDIE("","HLJ","","SDFLD","HLCSTCP") ;HL*1.6*109
- ;L -^HLCS(870,HLDP,0)
- Q
- ;
-EXITS(Y) ; shutdown and clean up the listener process for either
- ; single-threaded or multi-threaded
+ S HLJ(870,HLDP_",",14)=1
+ D FILE^HLDIE("","HLJ","","SDFLD","HLCSTCP") ;HL*1.6*109
+ L -^HLCS(870,HLDP,0)
+ Q
+ ;
+EXITS(Y) ; Single service shutdown and cleans up
  N HLJ,X
  F  L +^HLCS(870,HLDP,0):2 Q:$T
@@ -266,11 +209,7 @@
  L -^HLCS(870,HLDP,0)
  I $D(ZTQUEUED) S ZTREQ="@"
- ; HL*1.6*122
- L -^HLCS("HLTCPLINK",HLDP)
  Q
  ;
 EXITM ;Multiple service shutdown and clean up
- ; shutdown and clean up a connection spawned by the listener
- ; process for a multi-threaded listener
  D UPDT(0)
  I $D(ZTQUEUED) S ZTREQ="@"
Index: FOIAVistA/tag/r/HEALTH_LEVEL_SEVEN-HL/HLCSTCP1.m
===================================================================
--- FOIAVistA/trunk/r/HEALTH_LEVEL_SEVEN-HL/HLCSTCP1.m	(revision 631)
+++ FOIAVistA/tag/r/HEALTH_LEVEL_SEVEN-HL/HLCSTCP1.m	(revision 636)
@@ -1,4 +1,4 @@
-HLCSTCP1 ;SFIRMFO/RSD - BI-DIRECTIONAL TCP ;10/17/2007  12:59
- ;;1.6;HEALTH LEVEL SEVEN;**19,43,57,64,71,133,132,122**;OCT 13,1995;Build 14
+HLCSTCP1 ;SFIRMFO/RSD - BI-DIRECTIONAL TCP ;7/28/07  08:58
+ ;;1.6;HEALTH LEVEL SEVEN;**19,43,57,64,71,133,132,122**;OCT 13,1995;Build 4
  ;Per VHA Directive 2004-038, this routine should not be modified.
  ;Receiver
@@ -12,18 +12,11 @@
  ; variable to replace ^TMP
  N HLTMBUF
- ;
  ; for HL7 application proxy user
- ;; N HLDUZ,DUZ  ; patch HL*1.6*122 TEST v2: DUZ code removed
- N HLDUZ
- S HLDUZ=+$G(DUZ)
- ;
+ N HLDUZ,DUZ
  D MON^HLCSTCP("Open")
  ; K ^TMP("HLCSTCP",$J,0)
  S HLMIEN=0,HLASTMSG=""
- ;
- ; patch HL*1.6*122 TEST v2: DUZ code removed
  ; set DUZ for application proxy user
- ;; D PROXY^HLCSTCP4
- ;
+ D PROXY^HLCSTCP4
  F  D  Q:$$STOP^HLCSTCP  I 'HLMIEN D MON^HLCSTCP("Idle") H 3
  . ; clean variables
@@ -31,9 +24,6 @@
  . S HLMIEN=$$READ
  . Q:'HLMIEN
- . ;
- . ; patch HL*1.6*122 TEST v2: DUZ code removed
  . ; DUZ comparison/reset for application proxy user
- . ;; D HLDUZ^HLCSTCP4
- . D HLDUZ2^HLCSTCP4
+ . D HLDUZ^HLCSTCP4
  . ; protect HLDUZ 
  . N HLDUZ
@@ -112,5 +102,5 @@
  . I HLBUFF[HLDEND,(HLBUFF("END")=0) S HLBUFF("END")=1
  ; detect disconnect for GT.M
- I $G(^%ZOSF("OS"))["GT.M",$DEVICE S $ECODE=",UREAD,"
+ I $G(^%ZOSF("OS"))["GT.M",$DEVICE S $ECODE=""
  ; timedout, <clean up>, quit
  ;I '$T,X="",HLX="" S HLACKWT=HLACKWT-HLDREAD D:HLACKWT<0&'HLHDR CLEAN Q
@@ -244,17 +234,6 @@
 SAVE(SRC,DEST) ;save into global & set top node
  ;SRC=source array (passed by ref.), DEST=destination global
- ;
- ; patch HL*1.6*122: MPI-client/server
- I DEST["HLMA" D
- . F  L +^HLMA(+HLIND1):10 Q:$T  H 1
- E  D
- . F  L +^HL(772,+$P(HLIND1,U,2)):10 Q:$T  H 1
- ;
  M @DEST=SRC
  S @DEST@(0)="^^"_HLINE_"^"_HLINE_"^"_DT_"^"
- ;
- I DEST["HLMA" L -^HLMA(+HLIND1)
- E  L -^HL(772,+$P(HLIND1,U,2))
- ;
  Q
  ;
@@ -277,7 +256,11 @@
  ;
 ERROR ; Error trap for disconnect error and return back to the read loop.
- ; patch HL*1.6*122
- ; move to routine HLCSTCP4 (splitted-size over 10000)
- D ERROR1^HLCSTCP4
+ S $ETRAP="D UNWIND^%ZTER"
+ I $$EC^%ZOSV["IOEOF" D UNWIND^%ZTER Q  ;VOE change for GT.M
+ I $$EC^%ZOSV["READ"!($$EC^%ZOSV["NOTOPEN")!($$EC^%ZOSV["DEVNOTOPN") D UNWIND^%ZTER Q
+ I $$EC^%ZOSV["WRITE" D CC("Wr-err") D UNWIND^%ZTER Q
+ I $ECODE["UREAD" D UNWIND^%ZTER Q  ; HL*1.6*122 GT.M
+ S HLCSOUT=1 D ^%ZTER,CC("Error")
+ D UNWIND^%ZTER
  Q
  ;
Index: FOIAVistA/tag/r/HEALTH_LEVEL_SEVEN-HL/HLCSTCP2.m
===================================================================
--- FOIAVistA/trunk/r/HEALTH_LEVEL_SEVEN-HL/HLCSTCP2.m	(revision 631)
+++ FOIAVistA/tag/r/HEALTH_LEVEL_SEVEN-HL/HLCSTCP2.m	(revision 636)
@@ -1,4 +1,4 @@
-HLCSTCP2 ;SFIRMFO/RSD - BI-DIRECTIONAL TCP ;10/17/2007  09:37
- ;;1.6;HEALTH LEVEL SEVEN;**19,43,49,57,63,64,66,67,76,77,87,109,133,122**;Oct 13,1995;Build 14
+HLCSTCP2 ;SFIRMFO/RSD - BI-DIRECTIONAL TCP ;09/13/2006
+ ;;1.6;HEALTH LEVEL SEVEN;**19,43,49,57,63,64,66,67,76,77,87,109,133**;Oct 13,1995;Build 13
  ;Per VHA Directive 2004-038, this routine should not be modified.
  ;Sender 
@@ -11,10 +11,7 @@
  S HLTCPO=HLDP,HLMSG="",(HLRETRY,HLRETMG)=0
  ;
- ; patch 122
- ; patch 133
- ; set IO(0) to the null device
- I $G(^%ZOSF("OS"))]"",^%ZOSF("OS")'["GT.M" D
- . S IO(0)=$S(^%ZOSF("OS")["OpenM":$S($$OS^%ZOSV()["VMS":"_NLA0:",$$OS^%ZOSV()["UNIX":"/dev/null",1:$P),^%ZOSF("OS")["DSM":"_NLA0:",1:$P)
- . O IO(0) U IO(0)
+ ;set IO(0) to the null device
+ S IO(0)=$S(^%ZOSF("OS")["OpenM":$S($$OS^%ZOSV()["VMS":"_NLA0:",$$OS^%ZOSV()["UNIX":"/dev/null",1:$P),^%ZOSF("OS")["DSM":"_NLA0:",1:$P)
+ O IO(0) U IO(0)
  ;
  ;persistent conection, open connection first, HLPORT=open port
@@ -39,21 +36,16 @@
  ; and then check the link if it open or not
  N HL,HLN,HLARR,HLHDR,HLI,HLJ,HLMSA,HLRESP,HLRESLT,HLRETRM,HLTCP,HLTCPI,X,Z,HLREREAD
- N HLTMBUF
- D MON^HLCSTCP("CheckOut")
+ D MON^HLCSTCP("Check out")
  ;HLMSG=next msg, set at tag DONE
  I 'HLMSG S HLMSG=+$O(^HLMA("AC","O",HLDP,0)),HLRETRY=0 Q:'HLMSG
  ;
+ ;**109**
+ ;Temporarily lock ^HLMA to flush buffer and ensure edits are complete
+ ;L +^HLMA(HLMSG):1 I '$T S HLMSG=0 Q
+ ;L -^HLMA(HLMSG)
+ ;
  S HLI=+$G(^HLMA(HLMSG,0)),HLJ=$O(^("MSH",0)),HLTCP=""
  ;don't have message text or MSH, kill x-ref and decrement 'to send'
- ;
- ; patch HL*1.6*122: MPI-client/server
- ; I 'HLI!'HLJ K ^HLMA("AC","O",HLDP,HLMSG) D LLCNT^HLCSTCP(HLDP,3,1) S HLMSG=0 Q
- I 'HLI!'HLJ D  Q
- . F  L +^HLMA("AC","O",HLDP,HLMSG):10 Q:$T  H 1
- . K ^HLMA("AC","O",HLDP,HLMSG)
- . L -^HLMA("AC","O",HLDP,HLMSG)
- . D LLCNT^HLCSTCP(HLDP,3,1)
- . S HLMSG=0
- ;
+ I 'HLI!'HLJ K ^HLMA("AC","O",HLDP,HLMSG) D LLCNT^HLCSTCP(HLDP,3,1) S HLMSG=0 Q
  ;update msg status to 'being transmitted'; if cancelled decrement link and quit
  I '$$CHKMSG(1.5) D LLCNT^HLCSTCP(HLDP,3,1) S HLMSG=0 Q
@@ -153,6 +145,4 @@
  ; Set up error trap
  N $ETRAP,$ESTACK S $ETRAP="D ERROR^HLCSTCP2"
- ; patch HL*1.6*122
- N HLTMBUF
  ;override ack timeout
  I $G(HLP("ACKTIME")) N HLDBACK S HLDBACK=HLP("ACKTIME")
@@ -179,4 +169,5 @@
  D STATUS^HLTF0(HLMSG,ST,$G(ERR),$G(ERRMSG),1)
  ;
+ ;**109**
  D DEQUE^HLCSREP(HLDP,"O",HLMSG)
  ;
@@ -189,4 +180,8 @@
  ;returns 1=msg was updated, 0=msg has been canceled
  N X
+ ;
+ ;**109**
+ ;F  L +^HLMA(HLMSG,"P"):1 Q:$T  H 1
+ ;
  ;
  ; New HL*1.6*77 code starting here...
@@ -195,14 +190,22 @@
  .  D STATUS^HLTF0(HLMSG,4,$P(HLERROR,U),$P(HLERROR,U,2),1)
  .;
+ .;**109**
  . D DEQUE^HLCSREP(HLDP,"O",HLMSG)
- ;
- ; End of HL*1.6*77
+ .;L -^HLMA(HLMSG,"P")
+ ;**end 109**
+ ;
+ ; End of HL*1.6*77 modifications
  ;
  ;get status, quit if msg was cancelled
  ;
+ ;**109**
+ ;S X=+^HLMA(HLMSG,"P") I X=3 L -^HLMA(HLMSG,"P") Q 0
  S X=+^HLMA(HLMSG,"P") Q:X=3 0
  ;
  ;update status if it is different
  I $G(HLI),HLI'=X D STATUS^HLTF0(HLMSG,HLI)
+ ;
+ ;**109**
+ ;L -^HLMA(HLMSG,"P")
  ;
  Q 1
@@ -216,6 +219,5 @@
  ;           -1 - Unsuccessful
  ;
- N HLDA2,HLAR,HLI,LINENO,X,CRCOUNT
- S CRCOUNT=0
+ N HLDA2,HLAR,HLI,LINENO,X
  ;set error trap, used when called from HLTP3
  ;
@@ -235,29 +237,12 @@
  .. ;first line, need start block char.
  .. S:LINENO=1 X=$C(11)_X
- .. ; HL*1.6*122
- .. ; I X]"" W X,!
- .. N LENGTH
- .. S LENGTH=$L(X)
- .. ; buffer should be limited to 512
- .. I LENGTH>512 D
- ... N X1
- ... F  Q:LENGTH<512  D
- .... S X1=$E(X,1,512),X=$E(X,513,999999)
- .... S LENGTH=$L(X)
- .... W X1,@IOF
- .. ;
- .. ; @IOF (! or #) for flush character
- .. I X]"" W X,@IOF S CRCOUNT=0
- .. ;send CR
- .. I X="" W $C(13) S CRCOUNT=CRCOUNT+1
- .. ; prevent from maxstring error
- .. I CRCOUNT>200 W @IOF S CRCOUNT=0
+ .. I X]"" W X,!
+ .. ;send CR for blank lines
+ .. I X="" W $C(13)
  .. S LINENO=LINENO+1
  ; Sends end block for this message
  S X=$C(28)_$C(13)
- ; U IO W X,!
- U IO W X,@IOF
- ;switch to null device
- I $G(IO(0))'="",$G(IO(0))'=IO U IO(0)
+ U IO W X,!
+ I $G(IO(0))'="",$G(IO(0))'=IO U IO(0) ;switch to null device if opened to prevent 'leakage'
  Q 1
  ;
@@ -271,6 +256,6 @@
  G OPENA^HLCSTCP3
  ;
-RDERR D RDERR^HLCSTCP4 Q
-ERROR D ERROR^HLCSTCP4 Q
+RDERR D RDERR^HLCSTCP4 Q  ; Exceeded 10,000 bytes, so split on 12/2/03-LJA
+ERROR D ERROR^HLCSTCP4 Q  ; Exceeded 10,000 bytes, so split on 12/2/03-LJA
  ;
 CC(X) ;cleanup and close
Index: FOIAVistA/tag/r/HEALTH_LEVEL_SEVEN-HL/HLCSTCP3.m
===================================================================
--- FOIAVistA/trunk/r/HEALTH_LEVEL_SEVEN-HL/HLCSTCP3.m	(revision 631)
+++ FOIAVistA/tag/r/HEALTH_LEVEL_SEVEN-HL/HLCSTCP3.m	(revision 636)
@@ -1,54 +1,16 @@
-HLCSTCP3 ;SFIRMFO/RSD - BI-DIRECTIONAL TCP ; 09/13/2006  15:36
- ;;1.6;HEALTH LEVEL SEVEN;**76,77,133,122**;OCT 13, 1995;Build 14
+HLCSTCP3 ;SFIRMFO/RSD - BI-DIRECTIONAL TCP ;09/13/2006
+ ;;1.6;HEALTH LEVEL SEVEN;**76,77,133**;OCT 13, 1995;Build 13
  ;Per VHA Directive 2004-038, this routine should not be modified.
  ;
-OPENA ;
- ; called from $$OPEN^HLCSTCP2 and this sub-routine OPENA
- ;
- I $G(HLMSG),$D(^HLMA(HLMSG,"P")) S HLPORTA=+$P(^("P"),U,6)
+OPENA I $G(HLMSG),$D(^HLMA(HLMSG,"P")) S HLPORTA=+$P(^("P"),U,6)
+ D MON^HLCSTCP("Open")
  S POP=1
- ;
- ; patch HL*1.6*122 start
- ; variable HLDRETR=re-transmit attemps (#870,200.02)
- ; variable HLTCPLNK("TIMEOUT")=timeout for 3rd parameter of CALL^%ZISTCP()
- ; defined in HLCSTCP routine
- ;
- I '$G(HLDRETR("COUNT")) S HLDRETR("COUNT")=1
- I '$G(HLTCPLNK("TIMEOUT")) S HLTCPLNK("TIMEOUT")=5
- S HLDRETR("COUNT-2")=HLDRETR("COUNT")+HLDRETR
- ; patch 133
- ; I $G(HLDIRECT("OPEN TIMEOUT")) D
- ; .S HLI=1
- ; .D CALL^%ZISTCP(HLTCPADD,HLTCPORT,HLDIRECT("OPEN TIMEOUT"))
- ; E  D
- ; .F HLI=1:1:HLDRETR D CALL^%ZISTCP(HLTCPADD,HLTCPORT) Q:'POP
  I $G(HLDIRECT("OPEN TIMEOUT")) D
- . D MON^HLCSTCP("Open")
- . D CALL^%ZISTCP(HLTCPADD,HLTCPORT,HLDIRECT("OPEN TIMEOUT"))
- . ; give site one more chance to override the application setup
- . I $G(POP),(HLTCPLNK("TIMEOUT")>HLDIRECT("OPEN TIMEOUT")) D
- .. D CALL^%ZISTCP(HLTCPADD,HLTCPORT,HLTCPLNK("TIMEOUT"))
+ .S HLI=1
+ .D CALL^%ZISTCP(HLTCPADD,HLTCPORT,HLDIRECT("OPEN TIMEOUT"))
  E  D
- . N COUNT
- . ; try to connect HLDRETR times
- . F HLDRETR("COUNT")=HLDRETR("COUNT"):1:HLDRETR("COUNT-2") D  Q:('POP)!($$STOP^HLCSTCP)
- .. D MON^HLCSTCP("Open")
- .. ; D CALL^%ZISTCP(HLTCPADD,HLTCPORT)
- .. D CALL^%ZISTCP(HLTCPADD,HLTCPORT,HLTCPLNK("TIMEOUT"))
- .. ;open error
- .. I POP D
- ... D CC^HLCSTCP2("Openfail")
- ... H $S(HLDRETR("COUNT")=1:0,HLDRETR("COUNT")<10:1,1:8)
- ... I '$D(^XTMP("HL7-Openfail",$J)) D
- .... S ^XTMP("HL7-Openfail",0)=$$FMADD^XLFDT($$NOW^XLFDT,3)_"^"_$$NOW^XLFDT
- .... S ^XTMP("HL7-Openfail",$J,"COUNT","FIRST")=HLDRETR("COUNT")_"^"_$$NOW^XLFDT
- ... S COUNT=$P($G(^XTMP("HL7-Openfail",$J,"COUNT","LAST")),"^")+1
- ... S ^XTMP("HL7-Openfail",$J,"COUNT","LAST")=COUNT_"^"_$$NOW^XLFDT
- ;
+ .F HLI=1:1:HLDRETR D CALL^%ZISTCP(HLTCPADD,HLTCPORT) Q:'POP
  ;set # of opens back in msg
- ; I $G(HLMSG),$D(^HLMA(HLMSG,"P")) S $P(^("P"),U,6)=HLPORTA+HLI
- I $G(HLMSG),$D(^HLMA(HLMSG,"P")) S $P(^("P"),U,6)=HLDRETR("COUNT")
- ; patch HL*1.6*122 end
- ;
+ I $G(HLMSG),$D(^HLMA(HLMSG,"P")) S $P(^("P"),U,6)=HLPORTA+HLI
  ;device open
  I 'POP S HLPORT=IO D  Q $S($G(HLERROR)]"":0,1:1)
@@ -61,26 +23,14 @@
  . U IO W "HELO "_$$KSP^XUPARAM("WHERE"),! R X:1
  ;openfail-try DNS lookup
- ;
- ; patch HL*1.6*122 start
- ;I '$D(HLDOM) S HLDOM=+$P(^HLCS(870,HLDP,0),U,7),HLDOM=$P($G(^DIC(4.2,HLDOM,0)),U) D:HLDOM]"" DNS
- I '$D(HLDOM) D
- . S HLDOM=+$P(^HLCS(870,HLDP,0),U,7),HLDOM=$P($G(^DIC(4.2,HLDOM,0)),U)
- . S HLDOM("DNS")=$P($G(^HLCS(870,+$G(HLDP),0)),"^",8)
- . D:HLDOM]""!($L(HLDOM("DNS"),".")>2) DNS
- ;
- Q:$$STOP^HLCSTCP 0
+ I '$D(HLDOM) S HLDOM=+$P(^HLCS(870,HLDP,0),U,7),HLDOM=$P($G(^DIC(4.2,HLDOM,0)),U) D:HLDOM]"" DNS
  ;HLIP=ip add. from DNS call, get first one and try open again
  I $D(HLIP) S HLTCPADD=$P(HLIP,","),HLIP=$P(HLIP,",",2,99) G:HLTCPADD OPENA
- ; open error
- ;cleanup and close
- ; patch 133
+ ;open error
  I $G(HLDIRECT("OPEN TIMEOUT")) D
- . D MON^HLCSTCP("Openfail")
- . I $D(HLPORT) D CLOSE^%ZISTCP K HLPORT
+ .D MON^HLCSTCP("Openfail")
+ .I $D(HLPORT) D CLOSE^%ZISTCP K HLPORT
  E  D
- . D CC^HLCSTCP2("Openfail")
+ .D CC^HLCSTCP2("Openfail") H 3
  Q 0
- ; patch HL*1.6*122 end
- ;
  ;
  ;following code was removed, site's complained of to many alerts
@@ -107,10 +57,4 @@
  I HLTCPORT=5000 S HLDOM="HL7."_HLDOM
  I HLTCPORT=5500 S HLDOM="MPI."_HLDOM
- ;
- ; patch HL*1.6*122 start
- I $L($G(HLDOM("DNS")),".")>2 D
- . S HLDOM=HLDOM("DNS")
- ; patch HL*1.6*122 end
- ;
  S HLIP=$$ADDRESS^XLFNSLK(HLDOM)
  K:HLIP="" HLIP
Index: FOIAVistA/tag/r/HEALTH_LEVEL_SEVEN-HL/HLCSTCP4.m
===================================================================
--- FOIAVistA/trunk/r/HEALTH_LEVEL_SEVEN-HL/HLCSTCP4.m	(revision 631)
+++ FOIAVistA/tag/r/HEALTH_LEVEL_SEVEN-HL/HLCSTCP4.m	(revision 636)
@@ -1,4 +1,4 @@
-HLCSTCP4 ;SFIRMFO/RSD - BI-DIRECTIONAL TCP ;10/18/2007  09:56
- ;;1.6;HEALTH LEVEL SEVEN;**109,122**;Oct 13,1995;Build 14
+HLCSTCP4 ;SFIRMFO/RSD - BI-DIRECTIONAL TCP ;11/03/2006  13:31
+ ;;1.6;HEALTH LEVEL SEVEN;**109,122**;Oct 13,1995;Build 4
  ;Per VHA Directive 2004-038, this routine should not be modified.
  ;
@@ -15,69 +15,35 @@
  ;I $G(HLMSG) L -^HLMA(HLMSG)
  ;
- ; patch HL*1.6*122 start
- N STOP
- S STOP=0
- I $G(HLDP) S STOP=$$STOP^HLCSTCP
  S $ETRAP="D UNWIND^%ZTER"
- S HLTCP("$ZA\8192#2")=""
- I (^%ZOSF("OS")["OpenM") D
- . S HLTCP("$ZA")=$ZA
- . ; For TCP devices $ZA\8192#2: the device is currently in the
- . ; Connected state talking to a remote host.
- . S HLTCP("$ZA\8192#2")=$ZA\8192#2
- ;
+ ; patch HL*1.6*122
+ S HLTCPERR("$P")=$P
  S HLTCPERR("ERR-$ZE")=$$EC^%ZOSV
  ; I $$EC^%ZOSV["OPENERR"!($$EC^%ZOSV["NOTOPEN")!($$EC^%ZOSV["DEVNOTOPN") D CC^HLCSTCP2("Op-err") S:$G(HLPRIO)="I" HLERROR="15^Open Related Error" D UNWIND^%ZTER Q
- I $$EC^%ZOSV["OPENERR"!($$EC^%ZOSV["NOTOPEN")!($$EC^%ZOSV["DEVNOTOPN") D  G:STOP H2^XUSCLEAN Q
- . D CC^HLCSTCP2("Op-err") H 1
+ I $$EC^%ZOSV["OPENERR"!($$EC^%ZOSV["NOTOPEN")!($$EC^%ZOSV["DEVNOTOPN") D  Q
+ . D CC^HLCSTCP2("Op-err")
  . S:$G(HLPRIO)="I" HLERROR="15^Open Related Error"
- . I STOP D  Q
- .. D CC^HLCSTCP2("Shutdown: (with 'Op-err')")
- . I 'STOP D UNWIND^%ZTER
- I $$EC^%ZOSV["WRITE" D  G:STOP!(HLTCP("$ZA\8192#2")=0) H2^XUSCLEAN Q
- . D CC^HLCSTCP2("Wr-err") H 1
- . S:$G(HLPRIO)="I" HLERROR="108^Write Error"
- . I STOP D  Q
- .. D CC^HLCSTCP2("Shutdown: (with 'Wr-err')")
- . I HLTCP("$ZA\8192#2")=0 D  Q
- .. D CC^HLCSTCP2("Halt (Wr): (Disconnected with 'Wr-err')")
- . I 'STOP,HLTCP("$ZA\8192#2") D UNWIND^%ZTER
+ . D UNWIND^%ZTER
+ I $$EC^%ZOSV["WRITE" D  Q  ;HL*1.6*77 modifications start here
+ .  D CC^HLCSTCP2("Wr-err")
+ .  S:$G(HLPRIO)="I" HLERROR="108^Write Error"
+ .  D UNWIND^%ZTER ;HL*1.6*77 modifications end here
  ; I $$EC^%ZOSV["READ" D CC^HLCSTCP2("Rd-err") S:$G(HLPRIO)="I" HLERROR="108^Read Error" D UNWIND^%ZTER Q
- I $$EC^%ZOSV["READ" D  G:STOP!(HLTCP("$ZA\8192#2")=0) H2^XUSCLEAN Q
- . D CC^HLCSTCP2("Rd-err") H 1
+ I $$EC^%ZOSV["READ" D  Q
+ . D CC^HLCSTCP2("Rd-err")
  . S:$G(HLPRIO)="I" HLERROR="108^Read Error"
- . I STOP D  Q
- .. D CC^HLCSTCP2("Shutdown: (with 'Rd-err')")
- . I HLTCP("$ZA\8192#2")=0 D  Q
- .. D CC^HLCSTCP2("Halt (Rd): (Disconnected with 'Rd-err')")
- . I 'STOP,HLTCP("$ZA\8192#2") D UNWIND^%ZTER
+ . D UNWIND^%ZTER
  S HLCSOUT=1 D ^%ZTER,CC^HLCSTCP2("Error"),SDFLD^HLCSTCP
  S:$G(HLPRIO)="I" HLERROR="9^Error"
- I STOP D CC^HLCSTCP2("Shutdown: (with 'Error')")
- I HLTCP("$ZA\8192#2")=0 D
- . D CC^HLCSTCP2("Halt (Er): (Disconnected with 'Error')")
- G:STOP!(HLTCP("$ZA\8192#2")=0) H2^XUSCLEAN
- ; patch HL*1.6*122 end
  D UNWIND^%ZTER
  Q
  ;
 PROXY ; set DUZ for application proxy user
- ;
- ; removed the execcution: patch 122 TEST v2
+ S HLDUZ=+$$APFIND^XUSAP("HLSEVEN,APPLICATION PROXY")
+ S DUZ=HLDUZ
+ D DUZ^XUP(DUZ)
  Q
  ;
- ;; S HLDUZ=+$$APFIND^XUSAP("HLSEVEN,APPLICATION PROXY")
- ;; S DUZ=HLDUZ
- ;; D DUZ^XUP(DUZ)
- ;; Q
- ;
 HLDUZ ; compare DUZ and set DUZ to application proxy user
- ;
- ; removed the execcution: patch 122 TEST v2
- Q
- ;
- ;; I '$G(HLDUZ) D PROXY
- ;
-HLDUZ2 ; compare DUZ and HLDUZ
+ I '$G(HLDUZ) D PROXY
  I $G(DUZ)'=HLDUZ D
  . S DUZ=HLDUZ
@@ -121,10 +87,5 @@
  I HLIND1 D  Q
  . ;get pointer to 772, kill header
- . ;
- . ; patch HL*1.6*122: MPI-client/server
- . F  L +^HLMA(+HLIND1):10 Q:$T  H 1
  . K ^HLMA(+HLIND1,"MSH")
- . L -^HLMA(+HLIND1)
- . ;
  . I $D(^HL(772,+$P(HLIND1,U,2),"IN")) K ^("IN")
  . S X=$$MAID^HLTF(+HLIND1,HLMID)
@@ -155,64 +116,2 @@
  Q X
  ;
-ERROR1 ;
- ; moved from ERROR^HLCSTCP1
- ; Error trap for disconnect error and return back to the read loop.
- ; patch HL*1.6*122 start
- I (^%ZOSF("OS")["OpenM") D
- . S HLTCP("$ZA")=$ZA
- . ; For TCP devices $ZA\8192#2: the device is currently in the
- . ; Connected state talking to a remote host.
- . S HLTCP("$ZA\8192#2")=$ZA\8192#2
- . I HLTCP("$ZA\8192#2")=0 D
- .. ; decrement counter of multi-listener
- .. I $D(^HLCS(870,"E","M",+$G(HLDP))) D EXITM^HLCSTCP
- .. ; process terminated
- .. D H2^XUSCLEAN
- S $ETRAP="D UNWIND^%ZTER"
- ; I $$EC^%ZOSV["READ"!($$EC^%ZOSV["NOTOPEN")!($$EC^%ZOSV["DEVNOTOPN") D UNWIND^%ZTER Q
- I ($$EC^%ZOSV["NOTOPEN")!($$EC^%ZOSV["DEVNOTOPN") D  Q
- . ; if it is not a multi-listener
- . I '$D(^HLCS(870,"E","M",+$G(HLDP))) D CC^HLCSTCP1("Open-err")
- . D UNWIND^%ZTER
- I $$EC^%ZOSV["READ" D  Q
- . ; if it is not a multi-listener
- . I '$D(^HLCS(870,"E","M",+$G(HLDP))) D CC^HLCSTCP1("Rd-err")
- . D UNWIND^%ZTER
- ;
- ; I $$EC^%ZOSV["WRITE" D CC("Wr-err") D UNWIND^%ZTER Q
- I $$EC^%ZOSV["WRITE" D  Q
- . ; if it is not a multi-listener
- . I '$D(^HLCS(870,"E","M",+$G(HLDP))) D CC^HLCSTCP1("Wr-err")
- . D UNWIND^%ZTER
- ;
- ; for GT.M
- I $ECODE["UREAD" D  Q
- . ; if it is not a multi-listener
- . I '$D(^HLCS(870,"E","M",+$G(HLDP))) D CC^HLCSTCP1("Rd-err")
- . D UNWIND^%ZTER
- ;
- ; S HLCSOUT=1 D ^%ZTER,CC("Error")
- S HLCSOUT=1
- D ^%ZTER
- ; if it is not a multi-listener
- I '$D(^HLCS(870,"E","M",+$G(HLDP))) D CC^HLCSTCP1("Error")
- ; patch HL*1.6*122 end
- ;
- D UNWIND^%ZTER
- Q
- ;
-CLRMCNTR ;
- ; clear the counter to set as "0 server" for multi-listener
- ; HL*1.6*122 start
- Q:'$G(HLDP)
- Q:'$D(^HLCS(870,"E","M",HLDP))
- S $P(^HLCS(870,HLDP,0),"^",4)="MS"
- S $P(^HLCS(870,HLDP,0),U,5)="0 server"
- Q
- ;
-CREATUSR ;
- ; patch HL*1.6*122 TEST v2: DUZ code removed
- ; create application proxy users for listeners and incoming filer
- ;; N HLTEMP
- ;; S HLTEMP=$$CREATE^XUSAP("HLSEVEN,APPLICATION PROXY","#")
- Q
Index: FOIAVistA/tag/r/HEALTH_LEVEL_SEVEN-HL/HLCSTCPA.m
===================================================================
--- FOIAVistA/trunk/r/HEALTH_LEVEL_SEVEN-HL/HLCSTCPA.m	(revision 631)
+++ FOIAVistA/tag/r/HEALTH_LEVEL_SEVEN-HL/HLCSTCPA.m	(revision 636)
@@ -1,37 +1,23 @@
-HLCSTCPA ;OIFO-O/RJH - (TCP/IP) VMS ;07/26/2007  10:29
- ;;1.6;HEALTH LEVEL SEVEN;**84,122**;Oct 13, 1995;Build 14
- ;Per VHA Directive 2004-038, this routine should not be modified.
+HLCSTCPA ;OIFO-O/RJH - (TCP/IP) VMS ;07/10/2003  10:12
+ ;;1.6;HEALTH LEVEL SEVEN;**84**;Oct 13, 1995
  ;
- ; 1. port number is input from VMS COM file, such as HLSxxxxDSM.COM,
- ;    HLSxxxxCACHE.COM, or HLSxxxxGTM.COM file, where xxxx is port
- ;    number.
- ; 2. find the ien of #870(logical link file) for the multi-listener
+ ; 1. port number is input from VMS HLSxxxxDSM.COM or HLSxxxxCACHE.COM
+ ;    file, where xxxx is port number.
+ ; 2. find the ien of #870(logical link file) for the HL7 multi-listener
+ ; 3. call the appropriate entry:
+ ;    for Cache: CACHEVMS^HLCSTCP(ien of #870)
+ ;    for DSM:   EN^HLCSTCP
  Q
+PORT ;
+ ;HLIEN870: ien in #870 (logical link file)
+ ;HLPORT: port number of multi-listener
+ ;HLPRTS: port number in entry to be tested
+ ;input of DSM: % = device^port number of multi-listener
+ ;input of Cache: port number of TCPIP
  ;
-GTMPORT(%) ; From tcpip ZFOO for GT.M
- ; %: device^port number
- N HLPORT
- S HLPORT=$P($G(%),"^",2)
- I $G(^%ZOSF("OS"))'["GT.M" D ^%ZTER Q
- D IEN
- Q
- ;
-PORT ;
- ; HLPORT: port number of multi-listener
- ; input of DSM: % = device^port number of multi-listener
- ; input of Cache: port number of TCPIP
- ;
- N HLPORT
- S HLPORT=0
  I ^%ZOSF("OS")["OpenM" D
  . S HLPORT=$ZF("GETSYM","PORT")
  I ^%ZOSF("OS")["DSM" D
  . S HLPORT=$P(%,"^",2)
- ;
-IEN ;
- ; HLIEN870: ien in #870 (logical link file)
- ; HLPRTS: port number in entry to be tested
- ;
- N HLIEN870
  I 'HLPORT D ^%ZTER Q
  S HLIEN870=0
@@ -41,10 +27,8 @@
  ;
  K HLPORT,HLPRTS
- ; patch 122
- S U="^"
  ;
  ;for Cache/VMS
  I ^%ZOSF("OS")["OpenM" D  Q
- . D CACHEVMS(HLIEN870)
+ .D CACHEVMS^HLCSTCP(HLIEN870)
  ;
  ;for DSM
@@ -52,62 +36,6 @@
  . S $P(%,"^",2)=HLIEN870   ;set % = device^ien of #870
  . K HLIEN870
- . D EN
- ;
- ;for GT.M
- I ^%ZOSF("OS")["GT.M" D  Q
- . S HLDP=HLIEN870   ;set HLDP = ien of #870
- . K HLIEN870
- . D GTMUCX
+ . D EN^HLCSTCP
  ;
  D ^%ZTER
  Q
-GTMUCX ; GT.M /VMS tcpip
- ;listener,  % = device^port
- S U="^",IO=$P(%,U)
- ; S IO(0)=$P O IO(0) ;Setup null device
- ; GTM specific code
- S @("$ZINTERRUPT=""I $$JOBEXAM^ZU($ZPOSITION)""")
- X "O IO:(RECORDSIZE=512)"
- D LISTEN^HLCSTCP
- C IO
- Q
- ;
- ; $ x=f$trnlnm("sys$net")  !This is our MBX device
- ; $!
- ; $! for GT.M
- ; $ assign 'f$trnlnm("SYS$NET")' SYS$NET
- ; $! Depending on how your command files are set up, you may need to
- ; $! run the GT.M profile file.
- ; $ @<user$:[gtmmgr]>gtmprofile.com
- ; $ forfoo="$" + f$parse("user$:[gtmmgr.r]ZFOO.exe")
- ; $ PORT=5000
- ; $ data="''x'^''PORT'"
- ; $ forfoo GTMPORT^HLCSTCPA("''data'")
- ;
-CACHEVMS(%) ;Cache'/VMS tcpip
- ;listener,  % = HLDP
- I $G(%)="" D ^%ZTER Q
- ; patch 133
- S IO="SYS$NET",U="^",HLDP=%
- S IO(0)="_NLA0:" O IO(0) ;Setup null device
- ; **Cache'/VMS specific code**
- O IO::5 E  D MON^HLCSTCP("Openfail") Q
- X "U IO:(::""-M"")" ;Packet mode like DSM
- D LISTEN^HLCSTCP
- C IO
- Q
- ;
-EN ; DSM/VMS tcpip
- ;listener,  % = device^HLDP
- I $G(%)="" D ^%ZTER Q
- ; patch 122
- ; S IO="SYS$NET",U="^",HLDP=$P(%,U,2)
- S U="^",IO=$P(%,U),HLDP=$P(%,U,2)
- ; patch 133
- S IO(0)="_NLA0:" O IO(0) ;Setup null device
- ; **VMS specific code, need to share device**
- O IO:(TCPDEV):60 E  D MON^HLCSTCP("Openfail") Q
- ; patch 122
- D LISTEN^HLCSTCP
- C IO
- Q
